<?php

class Andy_AudioPlus_DataWriter extends XFCP_Andy_AudioPlus_DataWriter
{
	public function save()
	{		
		// call parent function
		parent::save();
		
		// define variables
		$updateRequired = '';
		$newMessage = '';
		
		// get current post_id
		$currentPostId = $this->get('post_id');

		// get current message
		$currentMessage = $this->get('message');
		
		//#####################################
		// check if post has attachments
		//#####################################
		
		// get database
		$db = XenForo_Application::get('db');		
		
		// run query
		$attachments = $db->fetchAll("
			SELECT attachment_id
			FROM xf_attachment
			WHERE content_id = ?
			AND content_type = 'post'
		", $currentPostId);	
		
		// get attachmentCount
		$attachmentCount = count($attachments);	
		
		// continue if there are attachments
		if ($attachmentCount > 0)
		{
			// run query
			$attachmentData = $db->fetchAll("
				SELECT xf_attachment.attachment_id, xf_attachment_data.filename, xf_post.message
				FROM xf_attachment
				INNER JOIN xf_attachment_data ON xf_attachment_data.data_id = xf_attachment.data_id
				INNER JOIN xf_post ON xf_post.post_id = xf_attachment.content_id
				WHERE xf_attachment.content_id = ?
				AND xf_attachment.content_type = 'post'
				ORDER BY xf_attachment.attachment_id ASC
			", $currentPostId);	
			
			// declre variable
			$attachment_id = array();
				
			foreach ($attachmentData AS $k => $v)
			{
				$attachment_id[] = $v['attachment_id'];
				$filename[] = $v['filename'];
				$message[] = $v['message'];
				
				$attachment[] = array(
					'attachment_id' => $v['attachment_id'],
					'filename' => $v['filename']
				);
			}
			
			$count = count($attachment_id);
			
			//#####################################
			// start main loop
			//#####################################
		
			for ($i=0; $i<$count; $i++)
			{
				//#####################################
				// parse the message and look for attachment tags
				// each loop will process one attachment_id
				//#####################################		
				
				// clear variable for each loop
				$check_for_proper_insert = '';
				
				$pos1 = stripos($filename[$i], '.mp3');
				if (is_numeric($pos1)) {
					$check_for_proper_insert = 'yes';
				}				
		
				// insert attachment
				if ($check_for_proper_insert == 'yes') {					

					// get webRoot
					$webRoot = XenForo_Link::buildPublicLink('full:index');
					
					// remove index.php if not using full friendly url's
					$replace_src = 'index.php';
					$replace_str = '';
					$text = $webRoot;					
					$webRoot = str_replace($replace_src, $replace_str, $text);
					
					// get attachmentUrl
					$attachmentUrl = $webRoot . XenForo_Link::buildPublicLink('attachments', $attachment[$i]);
					
					// create attachcode
					$attachcode = '[AUDIOPLUS=' . $attachmentUrl . '][/AUDIOPLUS]';				
					
					if ($newMessage == '')
					{
						$pos1 = stripos($message[$i], $attachcode);
					}
					else
					{
						$pos1 = stripos($newMessage, $attachcode);
					}
					
					// if attachment code not found, prepare new message with MEDIA=audioplus tag
					if ($pos1 === false)
					{						
						if ($newMessage == '')
						{
							$newMessage = $message[$i] . '
' . '
' . $attachcode;
						}
						else
						{
							$newMessage = $newMessage . '
' . '
' . $attachcode;
						}						

						//#####################################
						// set updateRequired flag
						//#####################################
						
						$updateRequired = 'yes';
					}
				}			
			}
		}		

		if ($updateRequired == 'yes')
		{			
			//#####################################
			// update xf_post.message
			//#####################################
			
			$db = XenForo_Application::get('db');	
			
			$db->query('
				UPDATE xf_post SET
					message = ?
				WHERE post_id = ?
			', array($newMessage, $currentPostId));	
			
			//#####################################
			// delete xf_bb_code_parse_cache
			//#####################################		
			
			$db->query("
				DELETE FROM xf_bb_code_parse_cache
				WHERE content_id = ?
				AND content_type = 'post'
			", $currentPostId);
			
			//#####################################
			// update ElasticSearch post index
			//#####################################
			
			// check if ElasticSearch is enabled
			if (XenForo_Application::get('options')->enableElasticsearch)
			{
				// get ElasticSearch options	
				$esServerOption = XenForo_Application::get('options')->elasticSearchServer;
				
				// get ElasticSearch port number
				$esPort = $esServerOption['port'];
				
				// get ElasticSearch index name
				$indexName = XenES_Api::getInstance()->getIndex();

				// delete current post data in ElasticSearch
				exec("curl -XDELETE 'http://localhost:" . $esPort . "/" . $indexName . "/post/'" . $currentPostId . "'");
				
				// prepare data
				$dataString = '{
					"message" : "' . $newMessage . '"
				}';
				
				$ch = curl_init('http://localhost:' . $esPort . '/' . $indexName . '/post/' . $currentPostId);
				curl_setopt($ch, CURLOPT_RETURNTRANSFER, TRUE);
				
				curl_setopt($ch, CURLOPT_HTTPHEADER, array(                                                                          
				'Content-Type: application/json',                                                                                
				'Content-Length: ' . strlen($dataString))                                                                       
				); 
				 
				curl_setopt($ch, CURLOPT_POSTFIELDS, $dataString );
				curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'PUT');
				
				// execute curl
				curl_exec($ch);
			}
		}
	}	
}